/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package tp2;

import java.io.IOException;
import java.io.PrintWriter;
import java.util.ArrayList;
import java.util.Collection;
import javax.ejb.EJB;
import javax.servlet.RequestDispatcher;
import javax.servlet.ServletException;
import javax.servlet.annotation.WebServlet;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

/**
 *
 * @author ediltondossantos
 */
@WebServlet(name="ServletClient", urlPatterns={"/ServletClient"})
public class ServletClient extends HttpServlet {
    @EJB
    private GestionnaireDeClientLocal gestionnaireDeClient;
    /**
     * Processes requests for both HTTP <code>GET</code> and <code>POST</code> methods.
     * @param request servlet request
     * @param response servlet response
     * @throws ServletException if a servlet-specific error occurs
     * @throws IOException if an I/O error occurs
     */
    protected void processRequest(HttpServletRequest request, HttpServletResponse response)
    throws ServletException, IOException {
        response.setContentType("text/html;charset=UTF-8");
        PrintWriter out = response.getWriter();

        String action = request.getParameter("action");

         String forwardTo = "";
         String message = "";
         String erreur=("erreur");
         try{

               if(action.equals("generer")){
                   erreur="Comptes non créées";
                 gestionnaireDeClient.creerClientsTest();
                     RequestDispatcher dp = request.getRequestDispatcher("home.jsp");
                     dp.forward(request, response);
               }
             if (action.equals("afficherLesClients")) {
                 int page=Integer.parseInt(request.getParameter("page"));
                 Collection<Client> clients=gestionnaireDeClient.afficherTout(page);
                 if(clients.isEmpty()){
                     erreur="Aucun client";
             request.setAttribute("erreur", erreur);

                     RequestDispatcher dp = request.getRequestDispatcher("erreur.jsp");
                     dp.forward(request, response);
                 }
                 Collection<Client> c1=gestionnaireDeClient.afficherTout(page+1);
                 if(c1.isEmpty())
                     request.setAttribute("pageStop", "stop");
                 else
                     request.setAttribute("pageStop", "continue");
                 request.setAttribute("page", page);
                 request.setAttribute("Clients", clients);

                     RequestDispatcher dp = request.getRequestDispatcher("afficherClient.jsp");
                     dp.forward(request, response);
         }
               if (action.equals("supprimer")) {
             int id=Integer.parseInt(request.getParameter("id"));
             erreur="Client non supprimé";
                 gestionnaireDeClient.supprimer(id);
             erreur="Client supprimé";
             request.setAttribute("erreur", erreur);

                     RequestDispatcher dp = request.getRequestDispatcher("erreur.jsp");
                     dp.forward(request, response);
         }
          if (action.equals("afficherLesComptes")) {
                 int id=Integer.parseInt(request.getParameter("id"));
                 Client client=gestionnaireDeClient.getClient(id);
            Collection<CompteBancaire> c=client.getComptesBancaires();
            if(c.isEmpty()){
                     erreur="Aucun compte";
             request.setAttribute("erreur", erreur);

                     RequestDispatcher dp = request.getRequestDispatcher("erreur.jsp");
                     dp.forward(request, response);
                 }
                     request.setAttribute("pageStop", "stop");
                     request.setAttribute("proprietaire",client.getPrenom()+ " " +client.getNom());
            request.setAttribute("page", 1);
                     request.setAttribute("ListeDesComptes",c);
                     

                     RequestDispatcher dp = request.getRequestDispatcher("afficheurDeComptes.jsp");
                     dp.forward(request, response);
         }
         if (action.equals("afficherLesClientsTransfert")) {
                 int page=Integer.parseInt(request.getParameter("page"));
                 Collection<Client> clients=gestionnaireDeClient.afficherTout(page);
                 if(clients.isEmpty()){
                     erreur="Aucun client";
             request.setAttribute("erreur", erreur);

                     RequestDispatcher dp = request.getRequestDispatcher("erreur.jsp");
                     dp.forward(request, response);
                 }
                 Collection<Client> c1=gestionnaireDeClient.afficherTout(page+1);
                 if(c1.isEmpty())
                     request.setAttribute("pageStop", "stop");
                 else
                     request.setAttribute("pageStop", "continue");
                 request.setAttribute("selection", request.getParameter("selection"));
                 request.setAttribute("compte", request.getParameter("compte"));
                 request.setAttribute("Clients", clients);

                     RequestDispatcher dp = request.getRequestDispatcher("afficherClient.jsp");
                     dp.forward(request, response);
         }

         if (action.equals("recherche")) {
             int id = 0;
             erreur="Aucun résultat";
             try {
             id=Integer.parseInt(request.getParameter("recherche"));
                 CompteBancaire compte=gestionnaireDeClient.getCompte(id);
                 if(compte==null){
                     erreur="Aucun compte pour ce numéro";
             request.setAttribute("erreur", erreur);

                     RequestDispatcher dp = request.getRequestDispatcher("erreur.jsp");
                     dp.forward(request, response);
                 }
                 Collection<CompteBancaire> comptes=new ArrayList();
                 comptes.add(compte);
                 request.setAttribute("page", 1);
                     request.setAttribute("ListeDesComptes",comptes);

                     RequestDispatcher dp = request.getRequestDispatcher("afficheurDeComptes.jsp");
                     dp.forward(request, response);
             } catch (Exception e) {
                String str2=request.getParameter("recherche");
                int page=Integer.parseInt(request.getParameter("page"));
                request.setAttribute("page", page);
                request.setAttribute("selection", "recherche");
                Collection<Client> clients=gestionnaireDeClient.getClientByNP(str2, page);
                if(clients.isEmpty()){
                     erreur="Aucun client pour ce nom";
             request.setAttribute("erreur", erreur);

                     RequestDispatcher dp = request.getRequestDispatcher("erreur.jsp");
                     dp.forward(request, response);
                 }
                Collection<Client> c1=gestionnaireDeClient.getClientByNP(str2, page+1);
                 if(c1.isEmpty())
                     request.setAttribute("pageStop", "stop");
                 else
                     request.setAttribute("pageStop", "continue");
                request.setAttribute("Clients", clients);

                     RequestDispatcher dp = request.getRequestDispatcher("afficherClient.jsp");
                     dp.forward(request, response);
             }

         }

         if (action.equals("nvClient")) {
             erreur="Champs mal remplis";
        String nom=request.getParameter("nom");
             String prenom=request.getParameter("prenom");
             String adresse=request.getParameter("adresse");
             String telephone=request.getParameter("telephone");
             Client client=gestionnaireDeClient.creerClient(nom, prenom, adresse, telephone);
             request.setAttribute("nvId2", client.getId());
                     RequestDispatcher dp = request.getRequestDispatcher("nouveauCompte.jsp");
                     dp.forward(request, response);
                     }

         if(action.equals("ajouterCompte")){
             int id=Integer.parseInt(request.getParameter("id"));
             String type=request.getParameter("type");
             erreur="Veuiller indiquer le solde du nouveau compte";
             int solde=Integer.parseInt(request.getParameter("solde"));
             CompteBancaire compte=new CompteBancaire();
                 if(type.equals("courant"))
                 compte=new CompteCourant(type,solde);
                 if(type.equals("epargne"))
                 compte=new CompteEpargne(type,solde);
             gestionnaireDeClient.ajouterNouveauCompte(id, compte);
                     request.setAttribute("erreur", "Client ajouté");

                     RequestDispatcher dp = request.getRequestDispatcher("erreur.jsp");
                     dp.forward(request, response);
                     }
         if(action.equals("nvCompte")){
             erreur="Veuiller indiquer le solde du nouveau compte";
             int solde=Integer.parseInt(request.getParameter("solde"));
             String type=request.getParameter("type");
             String newOrNot1=request.getParameter("submit");

             if (newOrNot1.equals("ajouter")){
                 erreur="Aucun Client renseigné";
                 int id=Integer.parseInt(request.getParameter("id"));
                 CompteBancaire compte=new CompteBancaire();
                 if(type.equals("courant"))
                 compte=new CompteCourant(type,solde);
                 if(type.equals("epargne"))
                 compte=new CompteEpargne(type,solde);
                 gestionnaireDeClient.ajouterNouveauCompte(id, compte);
             }
             if (newOrNot1.equals(">>")){
                 int page=Integer.parseInt(request.getParameter("page"));
                 Collection<Client> clients=gestionnaireDeClient.afficherTout(page);
                 if(clients.isEmpty()){
                     erreur="Aucun client";
             request.setAttribute("erreur", erreur);

                     RequestDispatcher dp = request.getRequestDispatcher("erreur.jsp");
                     dp.forward(request, response);
                 }
                 Collection<Client> c1=gestionnaireDeClient.afficherTout(page+1);
                 if(c1.isEmpty())
                     request.setAttribute("pageStop", "stop");
                 else
                     request.setAttribute("pageStop", "continue");
                 request.setAttribute("Clients", clients);
                 request.setAttribute("solde", solde);
                 request.setAttribute("type", type);
                 request.setAttribute("selection", "NewOrNot");
                 request.setAttribute("page", page);
                     RequestDispatcher dp = request.getRequestDispatcher("afficherClient.jsp");
                     dp.forward(request, response);
             }
             if (newOrNot1.equals("nouveau client")){
                 request.setAttribute("solde", solde);
                 request.setAttribute("type", type);
                 request.setAttribute("nvId1", "5");

                     RequestDispatcher dp = request.getRequestDispatcher("nouveauClient.jsp");
                     dp.forward(request, response);
             }
             if (newOrNot1.equals("enregistrer")){
                 String nom=request.getParameter("nom");
             String prenom=request.getParameter("prenom");
             String adresse=request.getParameter("adresse");
             String telephone=request.getParameter("telephone");
             Client client=gestionnaireDeClient.creerClient(nom, prenom, adresse, telephone);
             CompteBancaire compte=new CompteBancaire();
                 if(type.equals("courant"))
                 compte=new CompteCourant(type,solde);
                 if(type.equals("epargne"))
                 compte=new CompteEpargne(type,solde);
             gestionnaireDeClient.ajouterNouveauCompte(client.getId(), compte);


                     request.setAttribute("erreur", "enregistré");

                     RequestDispatcher dp = request.getRequestDispatcher("erreur.jsp");
                     dp.forward(request, response);
             }
                     RequestDispatcher dp = request.getRequestDispatcher("home.jsp");
                     dp.forward(request, response);
                     }

               }catch(Exception e){
                   request.setAttribute("erreur", erreur);
                   RequestDispatcher dp = request.getRequestDispatcher("erreur.jsp");
                     dp.forward(request, response);
               }
    }



    // <editor-fold defaultstate="collapsed" desc="HttpServlet methods. Click on the + sign on the left to edit the code.">
    /**
     * Handles the HTTP <code>GET</code> method.
     * @param request servlet request
     * @param response servlet response
     * @throws ServletException if a servlet-specific error occurs
     * @throws IOException if an I/O error occurs
     */
    @Override
    protected void doGet(HttpServletRequest request, HttpServletResponse response)
    throws ServletException, IOException {
        processRequest(request, response);
    }

    /**
     * Handles the HTTP <code>POST</code> method.
     * @param request servlet request
     * @param response servlet response
     * @throws ServletException if a servlet-specific error occurs
     * @throws IOException if an I/O error occurs
     */
    @Override
    protected void doPost(HttpServletRequest request, HttpServletResponse response)
    throws ServletException, IOException {
        processRequest(request, response);
    }

    /**
     * Returns a short description of the servlet.
     * @return a String containing servlet description
     */
    @Override
    public String getServletInfo() {
        return "Short description";
    }// </editor-fold>

}
