package tp2;

/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */



import java.io.IOException;
import java.io.PrintWriter;
import java.util.ArrayList;
import java.util.Collection;
import javax.ejb.EJB;
import javax.servlet.RequestDispatcher;
import javax.servlet.ServletException;
import javax.servlet.annotation.WebServlet;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

/**
 *
 * @author ediltondossantos
 */
@WebServlet(name="ServletCompteBancaire", urlPatterns={"/ServletCompteBancaire"})
public class ServletCompteBancaire extends HttpServlet {
    @EJB
    private GestionnaireDeCompteBancaireLocal gestionnaireDeCompteBancaire;
   
    /** 
     * Processes requests for both HTTP <code>GET</code> and <code>POST</code> methods.
     * @param request servlet request
     * @param response servlet response
     * @throws ServletException if a servlet-specific error occurs
     * @throws IOException if an I/O error occurs
     */
    protected void processRequest(HttpServletRequest request, HttpServletResponse response)
    throws ServletException, IOException {
        response.setContentType("text/html;charset=UTF-8");
        PrintWriter out = response.getWriter();
       String action = request.getParameter("action");

         String forwardTo = "";
         String message = "";
         String erreur=("erreur");
         try{
             Collection<CompteBancaire> c = null;
         if (action.equals("creerCompteBancaire")) {
            gestionnaireDeCompteBancaire.creerComptesTest();

                     request.setAttribute("ListeDesComptes",c);
                     RequestDispatcher dp = request.getRequestDispatcher("afficheurDeComptes.jsp");
                     dp.forward(request, response);
         }
             if (action.equals("afficherLesComptes")) {
                 int page=Integer.parseInt(request.getParameter("page"));
            c=gestionnaireDeCompteBancaire.afficherTout(page);
            if(c.isEmpty()){
                     erreur="Aucun compte";
             request.setAttribute("erreur", erreur);

                     RequestDispatcher dp = request.getRequestDispatcher("erreur.jsp");
                     dp.forward(request, response);
                 }
            Collection<CompteBancaire> c1=gestionnaireDeCompteBancaire.afficherTout(page+1);
                 if(c1.isEmpty())
                     request.setAttribute("pageStop", "stop");
                 else
                     request.setAttribute("pageStop", "continue");
            request.setAttribute("page", page);
                     request.setAttribute("ListeDesComptes",c);
                     
                     RequestDispatcher dp = request.getRequestDispatcher("afficheurDeComptes.jsp");
                     dp.forward(request, response);
         }
             if (action.equals("afficherUnCompte")) {
             int id=Integer.parseInt(request.getParameter("recherche"));
                 CompteBancaire compte=gestionnaireDeCompteBancaire.getCompte(id);
                 Collection<CompteBancaire> comptes=new ArrayList();
                 comptes.add(compte);
                 if(comptes.isEmpty()){
                     erreur="Pas de résultat";
             request.setAttribute("erreur", erreur);

                     RequestDispatcher dp = request.getRequestDispatcher("erreur.jsp");
                     dp.forward(request, response);
                 }
                 request.setAttribute("ListeDesComptes", comptes);

                     RequestDispatcher dp = request.getRequestDispatcher("afficheurDeComptes.jsp");
                     dp.forward(request, response);
         }
             if (action.equals("supprimer")) {
             int id=Integer.parseInt(request.getParameter("id"));
                 gestionnaireDeCompteBancaire.supprimer(id);
                 erreur="Compte supprimé";
             request.setAttribute("erreur", erreur);

                     RequestDispatcher dp = request.getRequestDispatcher("erreur.jsp");
                     dp.forward(request, response);
         }
             if (action.equals("pageTransfert")) {
                 int compte=Integer.parseInt(request.getParameter("compte"));
                 int id = Integer.parseInt(request.getParameter("id"));
                 if (compte==1){
                     request.setAttribute("nom1", request.getParameter("nom"));
                     request.setAttribute("prenom1", request.getParameter("prenom"));
                     request.setAttribute("id1",id);
                     request.setAttribute("id2", request.getParameter("compte2"));
                     }
                 else{
                     request.setAttribute("nom2", request.getParameter("nom"));
                     request.setAttribute("prenom2", request.getParameter("prenom"));
                     request.setAttribute("id2",id);
                     request.setAttribute("id1", request.getParameter("compte1"));
                     }

                     RequestDispatcher dp = request.getRequestDispatcher("transfert.jsp");
                     dp.forward(request, response);
         }
             if (action.equals("afficherLesComptesTransfert")) {
                 if(request.getParameter("compte").equals("transfert")){
                     action="transfert";
                     }
                else{
                 int page=Integer.parseInt(request.getParameter("page"));
                 String compte=request.getParameter("compte");
                 String compte1=request.getParameter("compte1");
                 String compte2=request.getParameter("compte2");
            c=gestionnaireDeCompteBancaire.afficherTout(page);
            if(c.isEmpty()){
                     erreur="Aucun compte";
             request.setAttribute("erreur", erreur);

                     RequestDispatcher dp = request.getRequestDispatcher("erreur.jsp");
                     dp.forward(request, response);
                 }
            Collection<CompteBancaire> c1=gestionnaireDeCompteBancaire.afficherTout(page+1);
                 if(c1.isEmpty())
                     request.setAttribute("pageStop", "stop");
                 else
                     request.setAttribute("pageStop", "continue");
            request.setAttribute("compte1", compte1);
            request.setAttribute("compte2", compte2);
            request.setAttribute("page", page);
            request.setAttribute("selection", "transfert");
            request.setAttribute("compte", compte);
                     request.setAttribute("ListeDesComptes",c);

                     RequestDispatcher dp = request.getRequestDispatcher("afficheurDeComptes.jsp");
                     dp.forward(request, response);}
         }
             if (action.equals("pageTransfert")) {
                 String compte1Id = request.getParameter("compte1Id");
                 String compte1=request.getParameter("compte1");
                 request.setAttribute("compte1",compte1);
                 request.setAttribute("compte1Id",compte1Id);
                 request.setAttribute("ListeDesComptes",c);

                     RequestDispatcher dp = request.getRequestDispatcher("transfertComptes.jsp");
                     dp.forward(request, response);
         }
            if (action.equals("transfert")) {
                erreur="Champ compte mal renseigné";
                 int compte1 = Integer.parseInt(request.getParameter("compte1"));
                 int compte2 = Integer.parseInt(request.getParameter("compte2"));
                 erreur="Champ montant mal renseigné";
                 int montant = Integer.parseInt(request.getParameter("montant"));
                 String a=gestionnaireDeCompteBancaire.transfert(compte1, compte2, montant);
                 erreur=a;
                 request.setAttribute("erreur", erreur);
                     RequestDispatcher dp = request.getRequestDispatcher("erreur.jsp");
                     dp.forward(request, response);
         }
             if (action.equals("historiqueCompte")) {
                 int id = Integer.parseInt(request.getParameter("id"));
                 CompteBancaire compte=gestionnaireDeCompteBancaire.getCompte(id);
                 Collection<OperationBancaire> operations=compte.getOperations();
                 request.setAttribute("operations",operations);
                 String type=(compte.getClient().getPrenom()+" "+compte.getClient().getNom());
                 request.setAttribute("type", type);
                 request.setAttribute("id", id);
                 request.setAttribute("page", request.getParameter("page"));
                 if(operations.isEmpty()){
                     erreur="Aucune opération";
             request.setAttribute("erreur", erreur);

                     RequestDispatcher dp = request.getRequestDispatcher("erreur.jsp");
                     dp.forward(request, response);
                 }
                     RequestDispatcher dp = request.getRequestDispatcher("historiqueCompte.jsp");
                     dp.forward(request, response);
         }
             
             if (action.equals("afficherLesComptesParType")) {
                 
             int page=Integer.parseInt(request.getParameter("page"));
             String type=request.getParameter("type");
             if(type.equals("courant")){
                 c=gestionnaireDeCompteBancaire.afficherCompteCourant(page);
                 Collection<CompteBancaire> c1=gestionnaireDeCompteBancaire.afficherCompteCourant(page+1);
                 if(c1.isEmpty())
                     request.setAttribute("pageStop", "stop");
                 else
                     request.setAttribute("pageStop", "continue");
                 }
                 if(type.equals("epargne")){
                     c=gestionnaireDeCompteBancaire.afficherCompteEpargne(page);
                     Collection<CompteBancaire> c1=gestionnaireDeCompteBancaire.afficherCompteEpargne(page+1);
                 if(c1.isEmpty())
                     request.setAttribute("pageStop", "stop");
                 else
                     request.setAttribute("pageStop", "continue");

                     }
             if(c.isEmpty()){
                     erreur="Aucun compte";
             request.setAttribute("erreur", erreur);

                     RequestDispatcher dp = request.getRequestDispatcher("erreur.jsp");
                     dp.forward(request, response);
                 }
             
                    request.setAttribute("page", page);
                    request.setAttribute("selection", "type");
                    request.setAttribute("type", type);
                     request.setAttribute("ListeDesComptes",c);
                     RequestDispatcher dp = request.getRequestDispatcher("afficheurDeComptes.jsp");
                     dp.forward(request, response);
         }

             if (action.equals("nvCompte")) {
        String nom=request.getParameter("nom");
             String type=request.getParameter("type");
             int newOrNot=0;
             if (request.getParameter("submit").equals("nouveau client")){
                 newOrNot=1;
             request.setAttribute("newOrNot",newOrNot);
             int solde=Integer.parseInt(request.getParameter("solde"));
             CompteBancaire compte=new CompteBancaire();
                 if(type.equals("courant"))
                 compte=new CompteCourant(type,solde);
                 if(type.equals("epargne"))
                 compte=new CompteEpargne(type,solde);
             compte=gestionnaireDeCompteBancaire.creerCompteBancaire(compte);
             request.setAttribute("nvId1", compte.getId());
                     RequestDispatcher dp = request.getRequestDispatcher("nouveauClient.jsp");
                     dp.forward(request, response);
                     }
             }
             }catch(Exception e){
                   request.setAttribute("erreur", erreur);
                   RequestDispatcher dp = request.getRequestDispatcher("erreur.jsp");
                     dp.forward(request, response);
               }
                 
    } 

    // <editor-fold defaultstate="collapsed" desc="HttpServlet methods. Click on the + sign on the left to edit the code.">
    /** 
     * Handles the HTTP <code>GET</code> method.
     * @param request servlet request
     * @param response servlet response
     * @throws ServletException if a servlet-specific error occurs
     * @throws IOException if an I/O error occurs
     */
    @Override
    protected void doGet(HttpServletRequest request, HttpServletResponse response)
    throws ServletException, IOException {
        processRequest(request, response);
    } 

    /** 
     * Handles the HTTP <code>POST</code> method.
     * @param request servlet request
     * @param response servlet response
     * @throws ServletException if a servlet-specific error occurs
     * @throws IOException if an I/O error occurs
     */
    @Override
    protected void doPost(HttpServletRequest request, HttpServletResponse response)
    throws ServletException, IOException {
        processRequest(request, response);
    }

    /** 
     * Returns a short description of the servlet.
     * @return a String containing servlet description
     */
    @Override
    public String getServletInfo() {
        return "Short description";
    }// </editor-fold>

}
