<%--
    Document   : index
    Created on : 23 sept. 2010, 13:20:33
    Author     : ediltondossantos
--%>

<%@page contentType="text/html" pageEncoding="UTF-8"%>
<%@taglib uri="http://java.sun.com/jsp/jstl/core" prefix="c"%>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="fr" lang="fr">
    <c:import url="header.jsp"/>
<body>

<div id="header"></div><!-- Header -->
<div id="conteneur"><!-- Global -->

<div id="left">
<c:import url="model_left.jsp"/>
</div><!-- Fin Colonne de Gauche -->
<div id="right"><!-- Colonne de droite -->
    <c:import url="model_right.jsp"/>
        <div class="news"><!-- News -->
            <div align="center">
                <div class="affichage">
<div class="results">
                       <table width="700" border="1">
   <h3> Liste des comptes </h3>
   <caption>${proprietaire}</caption>

   <thead> <!-- En-tête du tableau -->
       <tr>
           <th>Type de compte</th>
           <th>N° de comtpe</th>
           <th>Propriétaire</th>
           <th>Solde</th>
           <th></th>
       </tr>
   </thead>
                              <tfoot> <!-- Pied de tableau -->

<tr>
           <th colspan="5">
               <c:if test="${selection!='transfert' and selection!='type'}">
               <c:if test="${page>1}">
               <input type="button" value="<<" onclick="self.location.href='ServletCompteBancaire?action=afficherLesComptes&page=${page-1}'"/>
               </c:if>
               ${page}
               <c:if test="${pageStop=='continue'}">
               <input type="button" value=">>" onclick="self.location.href='ServletCompteBancaire?action=afficherLesComptes&page=${page+1}'"/>
               </c:if>
               </c:if>
               <c:if test="${selection=='transfert'}">
               <c:if test="${page>1}">
               <input type="button" value="<<" onclick="self.location.href='ServletCompteBancaire?action=afficherLesComptesTransfert&compte=${compte}&compte1=${compte1}&compte2=${compte2}&selection=transfert&page=${page-1}'"/>
               </c:if>
               ${page}
               <c:if test="${pageStop=='continue'}">
               <input type="button" value=">>" onclick="self.location.href='ServletCompteBancaire?action=afficherLesComptesTransfert&compte=${compte}&compte1=${compte1}&compte2=${compte2}&selection=transfert&page=${page+1}'"/>
               </c:if>
               </c:if>
               <c:if test="${selection=='type'}">
               <c:if test="${page>1}">
               <input type="button" value="<<" onclick="self.location.href='ServletCompteBancaire?action=afficherLesComptesParType&type=${type}&page=${page-1}'"/>
               </c:if>
               ${page}
               <c:if test="${pageStop=='continue'}">
               <input type="button" value=">>" onclick="self.location.href='ServletCompteBancaire?action=afficherLesComptesParType&type=${type}&page=${page+1}'"/>
               </c:if>
               </c:if>
           </th>
       </tr>
   </tfoot>

   <tbody> <!-- Corps du tableau -->
       <c:set var="total" value="0"/>

                <c:forEach var="c" items="${requestScope['ListeDesComptes']}">
                            <tr>

                                <td>

                                    Compte ${c.type}</td>
                                <td>${c.id}</td>
                                <td>
                                    <c:if test="${selection=='transfert'}">
    <a href="ServletCompteBancaire?action=pageTransfert&compte1=${compte1}&compte2=${compte2}&id=${c.id}&compte=${compte}&prenom=${c.client.prenom}&nom=${c.client.nom}">
                                    ${c.client.prenom} ${c.client.nom}
</a></c:if>
 <c:if test="${selection!='transfert'}">
                                    ${c.client.prenom} ${c.client.nom}
                                    </c:if>
 </td>
                                <td>${c.solde}</td>
                                <td>
                                    <c:if test="${empty selection or selection=='type'}"><a href="ServletCompteBancaire?action=historiqueCompte&page=1&id=${c.id}">détail</a>
                                    <input type="image" src="images/transfert.png" width="14" heigth="16" onclick="self.location.href='ServletCompteBancaire?action=pageTransfert&cpte1=${c.id}&cpte2=&id=${c.id}&compte=1&prenom=${c.client.prenom}&nom=${c.client.nom}'"/>
                                    <input type="image" src="images/sup.png" width="16" heigth="18" onclick="self.location.href='ServletCompteBancaire?action=supprimer&id=${c.id}'"/>
                                    </c:if>
                                    <c:if test="${not empty selection and selection!='type'}">détail</c:if>
                                </td>
                            </tr>
                             <!-- On compte le nombre de -->
                        <c:set var="total" value="${total+1}"/>

                </c:forEach>
                            </tbody>

                        </table>
                    </div>
                </div>
            </div>
        </div> <!-- Fin News -->

<div class="clear"></div>
</div><!--  Fin Colonne de droite -->
</div> <!-- Fin global -->
<c:import url="model_foot.jsp"/>
</body>
</html>



